/*
 * @Author: 快乐橙 1760016317@qq.com
 * @Date: 2025-03-21 19:37:14
 * @LastEditors: 快乐橙 1760016317@qq.com
 * @LastEditTime: 2025-04-15 20:00:09
 * @FilePath: \tmerclub-platform\vite.config.js
 * @Description: 这是默认设置,请设置`customMade`, 打开koroFileHeader查看配置 进行设置: https://github.com/OBKoro1/koro1FileHeader/wiki/%E9%85%8D%E7%BD%AE
 */
import { defineConfig } from 'vite'
import vue from '@vitejs/plugin-vue'
import path from 'path'
import AutoImport from 'unplugin-auto-import/vite'
import Components from 'unplugin-vue-components/vite'
import { ElementPlusResolver } from 'unplugin-vue-components/resolvers'
import { createSvgIconsPlugin } from 'vite-plugin-svg-icons'
import viteCompression from 'vite-plugin-compression'
import legacy from '@vitejs/plugin-legacy'

// eslint
import eslintPlugin from 'vite-plugin-eslint'

// https://vitejs.dev/config/
export default defineConfig({
  plugins: [
    legacy({
      // 兼容浏览器列表
      targets: ['Android >= 7', 'chrome >= 51', 'firefox >= 54', 'ios >= 10']
    }),
    vue(),
    createSvgIconsPlugin({
      iconDirs: [path.resolve(process.cwd(), 'src/icons/svg')],
      symbolId: 'icon-[dir]-[name]'
    }),
    // 自动引入内容
    AutoImport({
      imports: [
        'vue',
        'vue-router'
      ],
      dirs: [
        'src/hooks/**',
        'src/stores/**',
        'src/utils/**'
      ],
      resolvers: [
        ElementPlusResolver()
      ],
      dts: 'src/auto-import/imports.d.ts',
      eslintrc: {
        enabled: true
      }
    }),
    // 自动引入组件
    Components({
      dirs: [
        'src/components'
      ],
      resolvers: [
        ElementPlusResolver()
      ],
      dts: 'src/auto-import/components.d.ts'
    }),
    // eslint
    eslintPlugin({
      include: ['src/**/*.js', 'src/**/*.vue', 'src/*.js', 'src/*.vue']
    }),
    // 对大于 1k 的文件进行压缩
    viteCompression({
      threshold: 1000,
    })
  ],
  server: {
    host: true,
    port: 9527,
    open: true
  },
  resolve: {
    alias: {
      '@': path.resolve(__dirname, 'src'),
      'vue-i18n': 'vue-i18n/dist/vue-i18n.cjs.js'
    }
  },
  build: {
    base: './',
    rollupOptions: {
      // 静态资源分类打包
      output: {
        chunkFileNames: 'static/js/[name]-[hash].js',
        entryFileNames: 'static/js/[name]-[hash].js',
        assetFileNames: 'static/[ext]/[name]-[hash].[ext]',
        // 静态资源分拆打包
        manualChunks (id) {
          if (id.includes('node_modules')) {
            if (id.toString().indexOf('.pnpm/') !== -1) {
              return id.toString().split('.pnpm/')[1].split('/')[0].toString();
            } else if (id.toString().indexOf('node_modules/') !== -1) {
              return id.toString().split('node_modules/')[1].split('/')[0].toString();
            }
          }
        }
      }
    },
    sourcemap: false,
    minify: 'terser',
    reportCompressedSize: false
  }
})
